<template>
  <div class="confirm">
    <div class="product-info">
      <div class="left">
        <image mode="aspectFit" class="product-img" :src="productInfo.image" alt=""/>
      </div>
      <div class="right">
        <div class="product-title">{{productInfo.productName}}</div>
        <div class="product-amount">
          <span class="label">数量：</span>
          <span class="label-value-num">{{productInfo.count}}</span>
        </div>
        <div class="product-integral">
          <span class="label">积分：</span>
          <span class="label-value-num">{{productInfo.exchangePoints}}</span>
        </div>
      </div>
    </div>
    <div class="product-price">
      <span class="cell-title">小计</span>
      <span class="cell-value">{{productInfo.total}}</span>
    </div>
    <div class="way-of-receiving">
      <div
        :class="[wayActive===index?'way-item-active':'','way-item']"
        v-for="(item,index) in waylist"
        :key="index"
        @click="wayActive = index"
      >{{item}}</div>
    </div>
    <div class="self-taking" v-if="wayActive === 0">
      <p class="self-taking-title">自取门店信息</p>
      <div class="shop-info">
        <div class="shop-info-title">
          <span class="shop-logo">GIADA</span>
          <span class="shop-name">{{storeAddress.storeName}}</span>
        </div>
        <p
          class="shop-address"
        >{{storeAddress.province}}{{storeAddress.city}}{{storeAddress.district}}</p>
      </div>
    </div>
    <div class="self-post" v-if="wayActive=== 1">
      <div class="select-address">
        <p class="select-title">邮寄地址</p>
        <div class="select-field" @click="event().toSelectAddress()">
          <span class="placeholder">
            <span v-if="!addressSession.province">请选择邮寄地址</span>
            <span v-if="addressSession.province">{{addressSession.province+addressSession.city+addressSession.district+addressSession.address}}</span>
            </span>
          <img class="arrow-down-icon" src="../../../../static/images/arrow-down.png" alt="">
        </div>
      </div>
    </div>
    <div class="btn-bg">
      <v-footer :footer="confirmTxt" @footerEmit="event().toChange()"></v-footer>
    </div>
    <v-verification ref="verification" @getCode="getCode" :show="show" @onCancel="onCancel" @onConfirm="onConfirm" :phone="phone"></v-verification>
    <v-hintbox :hintbox="hintbox" @close="close"></v-hintbox>
  </div>
</template>

<script type="text/ecmascript-6">
import config from "@/config";
import {
  VeevlinkLogin,
  VeevlinkIslogin,
  VeevlinkClient,
  VeevlinkData
} from "@/utils/base";
import verification from "@/components/verification";
import {
  get,
  showToast,
  setStorageSync,
  getStorageSync,
  scanCode
} from "@/util";
import {mapState} from 'vuex';
import store from "@/store";
import hintbox from "@/components/hintbox/hintbox.vue";
import footer from "@/components/footer/footer.vue";

export default {
  data() {
    return {
      show: false,
      wayActive: 0,
      address:'请选择邮寄地址',
      phone:'',
      code:'',
      productInfo: {
        color: "黑色",
        count: 1,
        productId: "",
        exchangeType: "",
        size: null,
        memberId: "",
        image: "",
        exchangePoints: null,
        productName: "",
        total: null
      },
      storeAddress: {
        city: "",
        district: "",
        memberId: null,
        province: "",
        storeId: "",
        storeName: "",
        type: null
      },
      addressInfo:{},
      affiliateProductId: "",
      queryInfo: {},
      confirmTxt: "立即兑换",
      changeInfo: {
        productId: "", //积分商城商品Id
        count: "", //数量
        memberId: "", //会员Id
        storeId: "", //门店Id(兑换商品-到店自取)
        phone: "", //手机号码(兑换商品-快递邮寄)
        receiverName: "", //收货人(兑换商品-快递邮寄)
        shippingAddr: "", //收货地址(兑换商品-快递邮寄)
        affiliateProductId: "", //附属商品Id(兑换商品)
        getWayInfo: "", //领取方式(兑换商品)
        openId: ""
      },
      waylist: ["到店自取", "快递邮寄"],
      num: 0,
      imgUrls: [
        "https://pic.8848phone.com/custom/8848/image/pic-login-header.png",
        "https://pic.8848phone.com/custom/8848/image/pic-login-header.png",
        "https://pic.8848phone.com/custom/8848/image/pic-login-header.png"
      ]
    };
  },
  computed: {
    ...mapState(['addressSession','goodsInfo'])
  },
  components: {
    "v-hintbox": hintbox,
    "v-footer": footer,
    "v-verification": verification
  },
  methods: {
    onCancel(data) {
      console.log(data);
      this.show = false;
    },
    onConfirm(data) {
      console.log(data);
      
      this.network().runApiToCheckCode()
    },
    getCode(code){
      this.code = code
    },
    /* =======事件区start======= */
    event() {
      return {
        toChange: () => {
          if (this.confirmTxt === "立即兑换") {
            // this.network().runApiToPostChange();
            this.show = true;
            // this.$refs.verification.handler().countDown()
            this.network().runApiToSendCode()
          }
        },
        toSelectAddress: () => {
          config.href(`${config.address.addlist}?type=select`);
        }
      };
    },
    /* =======事件区end======= */
    /* =======网络请求区start======= */
    network() {
      return {
        //todo:获取兑换详情
        runApiToGetConfirmInfo: query => {
          VeevlinkClient(
            "/points/product/exchange/info",
            "POST",
            this.productInfo,
            data => {
              if (data.success) {
                if (!data.records[0].isSufficientStock) {
                  this.confirmTxt = "已兑完";
                  return;
                }
                if (!data.records[0].isSufficientPoints) {
                  this.confirmTxt = "积分不足";
                }
                this.affiliateProductId = data.records[0].affiliateProductId;
                this.storeAddress = data.records[0].storeAddress;
                this.waylist = data.records[0].getWay;
              } else {
                wx.showToast({
                  title: success.message, //提示的内容,
                  icon: 'none', //图标,
                  duration: 2000, //延迟时间,
                });
              }
            },
            error => {
              console.log(error);
            }
          );
        },
        //todo:立即兑换
        runApiToPostChange: () => {
          let datalist = {
            openId: this.queryInfo.openId,
            count: this.productInfo.count,
            memberId: this.productInfo.memberId,
            productId: this.productInfo.productId,
            storeId: this.wayActive===0?this.storeAddress.storeId:'',
            phone: wx.getStorageSync("phonewx23bcedfe9e867c13").phoneNumber,
            receiverName:this.wayActive===1?this.addressInfo.name:'',
            shippingAddr: this.wayActive===1?this.addressSession.province+this.addressSession.city+this.addressSession.district+this.addressSession.address:'',
            affiliateProductId: this.affiliateProductId,
            getWayInfo: this.waylist[this.wayActive]
          };
          VeevlinkClient(
            "/points/product/exchange",
            "POST",
            datalist,
            data => {
              if (data.success) {
                 wx.showToast({
                  title:'兑换成功', //提示的内容,
                  icon: 'none', //图标,
                  duration: 1000, //延迟时间,
                  // mask: true, //显示透明蒙层，防止触摸穿透,
                  // success: res => {}
                });
                wx.reLaunch({ url: '/pages/shop/record/main' });
              } else {
                wx.showToast({
                  title: success.message, //提示的内容,
                  icon: 'none', //图标,
                  duration: 2000, //延迟时间,
                  // mask: true, //显示透明蒙层，防止触摸穿透,
                  // success: res => {}
                });
              }
            },
            error => {
              console.log(error);
            }
          );
        },
        //todo: 发送验证码
        runApiToSendCode:()=>{
          VeevlinkClient(
            `/member/verficationCode/get?phone=${this.phone}`,
            "GET",
            null,
            data => {
              if (data.success) {
                this.$refs.verification.handler().countDown()
              } else {
                this.hintbox.show = true;
                this.hintbox.text = success.message;
              }
            },
            error => {
              console.log(error);
            }
          );
        },
        // todo:验证验证码
        runApiToCheckCode:()=>{
          VeevlinkClient(
            `/services/apexrest/member/login?phone=${this.phone}&verificationCode=${this.code}&type=phone`,
            "GET",
            null,
            data => {
              if (data.success) {
                this.show = false;
                this.network().runApiToPostChange()
              } else {
                this.hintbox.show = true;
                this.hintbox.text = success.message;
              }
            },
            error => {
              console.log(error);
            }
          );
        }
      };
    }
    /* =======网络请求区end======= */
  },
  onReady(){
    
  },
  onShow(){

  },
  onLoad() {
    this.productInfo = this.goodsInfo
    this.productInfo.total = this.goodsInfo.count * this.goodsInfo.exchangePoints;
    this.queryInfo.openId = wx.getStorageSync(
      "informationwx23bcedfe9e867c13"
    ).OpenId;
    // if(wx.getStorageSync("addressInfo")){
    //   this.addressInfo = JSON.parse(wx.getStorageSync("addressInfo"))
    //   this.address = this.addressInfo.province+this.addressInfo.city+this.addressInfo.district+this.addressInfo.address
    // }
    this.phone = wx.getStorageSync('phonewx23bcedfe9e867c13').phoneNumber;
    this.network().runApiToGetConfirmInfo();
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" type="text/scss" scoped>
.confirm {
  padding: 40rpx 70rpx 0rpx 70rpx;
  box-sizing: border-box;
  width: 100%;
  .product-info {
    width: 100%;
    display: flex;
    .left {
      box-sizing: border-box;
      width: 177rpx;
      height: 177rpx;
      border: 1px solid rgba(151, 151, 151, 0.2);
      padding: 12rpx;
      margin-right: 40rpx;
      .product-img {
        width: 100%;
        height: 100%;
      }
    }
    .right {
      padding: 8rpx 0;
      .product-title {
        margin-bottom: 22rpx;
        font-size: 28rpx;
        font-family: GillSans-Light, GillSans;
      }
      .product-amount,
      .product-integral {
        margin-bottom: 13rpx;
        .label,
        .label-value-num {
          font-size: 24rpx;
          color: rgba(0, 0, 0, 0.4);
        }
        .label {
          font-family: STXihei;
        }
        .label-value-num {
          font-family: GillSans-Light, GillSans;
        }
      }
    }
  }
  .product-price {
    width: 100%;
    display: flex;
    justify-content: space-between;
    align-items: center;
    box-sizing: border-box;
    border-top: 1rpx solid #d8d8d8;
    border-bottom: 1rpx solid #d8d8d8;
    margin-top: 40rpx;
    padding: 42rpx 0;
    .cell-title {
      font-size: 22rpx;
      font-family: STXihei;
      color: rgba(0, 0, 0, 0.4);
    }
    .cell-value {
      font-weight: 300;
      font-size: 24rpx;
      font-family: GillSans-Light, GillSans;
      color: #333;
    }
  }
  .way-of-receiving {
    margin-top: 62rpx;
    margin-bottom: 72rpx;
    display: flex;
    justify-content: space-between;
    padding: 0 46rpx;
    .way-item {
      box-sizing: border-box;
      width: 225rpx;
      height: 60rpx;
      text-align: center;
      line-height: 60rpx;
      font-size: 28rpx;
      font-family: STXihei;
      color: rgb(184, 184, 184);
      border: 3rpx solid rgb(184, 184, 184);
    }
    .way-item-active {
      box-sizing: border-box;
      color: #333;
      border-color: #333;
    }
  }
  .self-taking {
    box-sizing: border-box;
    .self-taking-title {
      margin-bottom: 28rpx;
      font-size: 22rpx;
      font-family: STXihei;
      color: rgba(0, 0, 0, 0.4);
    }
    .shop-info {
      border: 1rpx solid rgba(0, 0, 0, 0.4);
      padding: 30rpx;
      .shop-info-title {
        margin-bottom: 25rpx;
        .shop-logo {
          font-size: 28rpx;
          font-family: GillSans-Light, GillSans;
          font-weight: 300;
          letter-spacing: 3rpx;
        }
        .shop-name {
          font-size: 28rpx;
          font-family: STXihei;
          color: #333;
        }
      }
      .shop-address {
        font-size: 24rpx;
        font-family: STXihei;
        color: #727171;
        line-height: 30rpx;
        line-height: 30rpx;
      }
    }
  }
  .self-post {
    .select-address {
      .select-title {
        font-size: 24rpx;
        font-family: STXihei;
        color: #727171;
      }
      .select-field {
        position: relative;
        display: flex;
        align-items: center;
        justify-content: space-between;
        margin-top: 14rpx;
        width: 610rpx;
        height: 60rpx;
        line-height: 60rpx;
        padding: 0 22rpx;
        background: #eaeaea;
        .placeholder {
          font-size: 28rpx;
        }
        .arrow-down-icon {
          width: 22rpx;
          height: 16rpx;
        }
      }
    }
  }
  .btn-bg {
    position: fixed;
    bottom: 0;
    left: 0;
    width: 100%;
    padding: 30rpx 0;
    text-align: left;
    box-shadow: 0px -1px 4px 0px rgba(0, 0, 0, 0.05);
  }
}
</style>
